Skip to content

Creates a new workflow record that does not already exist.

Request

This method will auto-generate an ID and create a new workflow. If an ID is specified for the workflow, an error will be thrown.

Security
knox-authorizer
Path
tenantIdstringrequired

The id of the tenant being accessed.

Bodyapplication/jsonrequired

The workflow that you would like to be saved.

context_idstring(Context)

If this is a contextual workflow, the ID

context_servicestring(Context Service)

If this is a contextual workflow, the service that has this context

date_trigger_optionsobject(Date Trigger Options)required
days_before_re_enrollment_is_allowednumber, (float)(Days Before Re Enrollment Is Allowed)

The amount of time that must pass before a record can reparticipate in this workflow. If blank a record may never re-enroll.

idstring(ID)^[\w|-]+$required

The unique, string identifier of this workflow

is_activeboolean(Is Active)

Whether or not this workflow is active

namestring(Name)required

The name of the workflow

record_change_trigger_optionsobject(Record Change Trigger Options)required
servicestring(Service)required

The service that owns this workflow

sys_bulk_load_atstring(Sys Bulk Load At)

If this record was loaded via bulk, the timestamp when the record was processed

sys_bulk_load_idstring(Sys Bulk Load)

If this record was loaded via bulk, the ID of the bulk load process

sys_bulk_load_pkstring(Sys Bulk Load Pk)

If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

sys_bulk_load_record_nonumber, (float)(Sys Bulk Load Record No)

If this record was loaded via bulk, the record number in the source file

sys_bulk_load_source_filestring(Sys Bulk Load Source File)

If this record was loaded via bulk, the source file

sys_calculated_field_errorstring(Sys Calculated Field Error)

The error associated with the calculated field

sys_calculated_field_errorsArray of objects
sys_configuration_snapshot_idstring(Sys Configuration Snapshot)

If a snapshot was restored/applies to this record, the ID of the snapshot

sys_context_keystring(Sys Context Key)required

System use only

sys_created_atstring, (date-time)(Sys Created At)required

The date/time that this record was created, expressed in ISO-8601 date format

sys_created_by_idstring(Sys Created By)required

The ID of the user that created this record

sys_deleted_by_idstring(Sys Deleted By)

The ID of the user that deleted (or last tried to delete) this object

sys_directivestring(Sys Directive)

Means for passing directive information into an object processing logic

sys_external_idstring(Sys External)

The ID that a record has from an external system or data import

sys_has_files_in_s3boolean(Sys Has Files In S3)

If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

sys_last_bulk_data_operation_idstring(Sys Last Bulk Data Operation)

If this record was last touched by a bulk data operation, the ID of that operation

sys_last_bulk_data_operation_sys_versionstring(Sys Last Bulk Data Operation Sys Version)

If this record was last touched by a bulk data operation, the sys_version at the time of that operation

sys_last_modified_atstring, (date-time)(Sys Last Modified At)required

The date/time that this record record was last modified, expressed in ISO-8601 date format

sys_last_modified_by_idstring(Sys Last Modified By)required

The ID of the user that last modified this record

sys_last_security_contextobject(Sys Last Security Context)

The security context of the last insert, modify, or delete performed on this item

sys_lockedboolean(Sys Locked)

If set, this record is locked and cannot be changed via the API

sys_snapshot_base_versionnumber, (float)(Sys Snapshot Base Version)

The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

sys_versionnumber, (float)(Sys Version)

A number representing the version of this record in the database

trigger_typestring(Trigger Type)required

What triggers the workflow

Enum:"date property""record change"
workflow_definitionobject(Workflow Definition)required

The workflow definition

curl -i -X POST \
  'https://docs.api.rhythmsoftware.com/_mock/apis/platform/platform-v1/workflows/{tenantId}' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "context_id": "string",
    "context_service": "string",
    "date_trigger_options": {
      "date_property": "string",
      "offset": "after",
      "time_interval": "days",
      "time_units": 0.1
    },
    "days_before_re_enrollment_is_allowed": 0.1,
    "id": "string",
    "is_active": true,
    "name": "string",
    "record_change_trigger_options": {
      "ruleset": {
        "all": [
          {
            "all": {},
            "any": {},
            "fact": "string",
            "operator": "contains",
            "path": "string",
            "value": "string"
          }
        ],
        "any": [
          {
            "all": {},
            "any": {},
            "fact": "string",
            "operator": "contains",
            "path": "string",
            "value": "string"
          }
        ]
      },
      "run_on_record_creation": true,
      "run_on_record_deletion": true,
      "run_on_record_modification": true,
      "run_only_when_certain_fields_change": [
        "string"
      ]
    },
    "service": "string",
    "sys_bulk_load_at": "string",
    "sys_bulk_load_id": "string",
    "sys_bulk_load_pk": "string",
    "sys_bulk_load_record_no": 0.1,
    "sys_bulk_load_source_file": "string",
    "sys_calculated_field_error": "string",
    "sys_calculated_field_errors": [
      {
        "error": "string",
        "field": "string"
      }
    ],
    "sys_configuration_snapshot_id": "string",
    "sys_context_key": "string",
    "sys_created_at": "2019-08-24T14:15:22Z",
    "sys_created_by_id": "string",
    "sys_deleted_by_id": "string",
    "sys_directive": "string",
    "sys_external_id": "string",
    "sys_has_files_in_s3": true,
    "sys_last_bulk_data_operation_id": "string",
    "sys_last_bulk_data_operation_sys_version": "string",
    "sys_last_modified_at": "2019-08-24T14:15:22Z",
    "sys_last_modified_by_id": "string",
    "sys_last_security_context": {},
    "sys_locked": true,
    "sys_snapshot_base_version": 0.1,
    "sys_version": 0.1,
    "trigger_type": "date property",
    "workflow_definition": {}
  }'

Responses

The workflow was saved successfully.

Headers
Access-Control-Allow-Headersstring
Access-Control-Allow-Methodsstring
Access-Control-Allow-Originstring
Bodyapplication/json
context_idstring(Context)

If this is a contextual workflow, the ID

context_servicestring(Context Service)

If this is a contextual workflow, the service that has this context

date_trigger_optionsobject(Date Trigger Options)required
days_before_re_enrollment_is_allowednumber, (float)(Days Before Re Enrollment Is Allowed)

The amount of time that must pass before a record can reparticipate in this workflow. If blank a record may never re-enroll.

idstring(ID)^[\w|-]+$required

The unique, string identifier of this workflow

is_activeboolean(Is Active)

Whether or not this workflow is active

namestring(Name)required

The name of the workflow

record_change_trigger_optionsobject(Record Change Trigger Options)required
servicestring(Service)required

The service that owns this workflow

sys_bulk_load_atstring(Sys Bulk Load At)

If this record was loaded via bulk, the timestamp when the record was processed

sys_bulk_load_idstring(Sys Bulk Load)

If this record was loaded via bulk, the ID of the bulk load process

sys_bulk_load_pkstring(Sys Bulk Load Pk)

If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

sys_bulk_load_record_nonumber, (float)(Sys Bulk Load Record No)

If this record was loaded via bulk, the record number in the source file

sys_bulk_load_source_filestring(Sys Bulk Load Source File)

If this record was loaded via bulk, the source file

sys_calculated_field_errorstring(Sys Calculated Field Error)

The error associated with the calculated field

sys_calculated_field_errorsArray of objects
sys_configuration_snapshot_idstring(Sys Configuration Snapshot)

If a snapshot was restored/applies to this record, the ID of the snapshot

sys_context_keystring(Sys Context Key)required

System use only

sys_created_atstring, (date-time)(Sys Created At)required

The date/time that this record was created, expressed in ISO-8601 date format

sys_created_by_idstring(Sys Created By)required

The ID of the user that created this record

sys_deleted_by_idstring(Sys Deleted By)

The ID of the user that deleted (or last tried to delete) this object

sys_directivestring(Sys Directive)

Means for passing directive information into an object processing logic

sys_external_idstring(Sys External)

The ID that a record has from an external system or data import

sys_has_files_in_s3boolean(Sys Has Files In S3)

If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

sys_last_bulk_data_operation_idstring(Sys Last Bulk Data Operation)

If this record was last touched by a bulk data operation, the ID of that operation

sys_last_bulk_data_operation_sys_versionstring(Sys Last Bulk Data Operation Sys Version)

If this record was last touched by a bulk data operation, the sys_version at the time of that operation

sys_last_modified_atstring, (date-time)(Sys Last Modified At)required

The date/time that this record record was last modified, expressed in ISO-8601 date format

sys_last_modified_by_idstring(Sys Last Modified By)required

The ID of the user that last modified this record

sys_last_security_contextobject(Sys Last Security Context)

The security context of the last insert, modify, or delete performed on this item

sys_lockedboolean(Sys Locked)

If set, this record is locked and cannot be changed via the API

sys_snapshot_base_versionnumber, (float)(Sys Snapshot Base Version)

The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

sys_versionnumber, (float)(Sys Version)

A number representing the version of this record in the database

trigger_typestring(Trigger Type)required

What triggers the workflow

Enum:"date property""record change"
workflow_definitionobject(Workflow Definition)required

The workflow definition

Response
{ "context_id": "string", "context_service": "string", "date_trigger_options": { "date_property": "string", "offset": "after", "time_interval": "days", "time_units": 0.1 }, "days_before_re_enrollment_is_allowed": 0.1, "id": "string", "is_active": true, "name": "string", "record_change_trigger_options": { "ruleset": { … }, "run_on_record_creation": true, "run_on_record_deletion": true, "run_on_record_modification": true, "run_only_when_certain_fields_change": [ … ] }, "service": "string", "sys_bulk_load_at": "string", "sys_bulk_load_id": "string", "sys_bulk_load_pk": "string", "sys_bulk_load_record_no": 0.1, "sys_bulk_load_source_file": "string", "sys_calculated_field_error": "string", "sys_calculated_field_errors": [ { … } ], "sys_configuration_snapshot_id": "string", "sys_context_key": "string", "sys_created_at": "2019-08-24T14:15:22Z", "sys_created_by_id": "string", "sys_deleted_by_id": "string", "sys_directive": "string", "sys_external_id": "string", "sys_has_files_in_s3": true, "sys_last_bulk_data_operation_id": "string", "sys_last_bulk_data_operation_sys_version": "string", "sys_last_modified_at": "2019-08-24T14:15:22Z", "sys_last_modified_by_id": "string", "sys_last_security_context": {}, "sys_locked": true, "sys_snapshot_base_version": 0.1, "sys_version": 0.1, "trigger_type": "date property", "workflow_definition": {} }